<?php
class Controller
{
    private $MainService;
    private $Params;
    public  $Controls;
    
    private $BgDir = '';
    private $SettingsList = array();
    
    function __construct ($service, $params, $controls) {
        $this->BgDir = S_DIR."background/";
        $this->SettingsList = unserialize(file_get_contents($this->BgDir."list.settings"));
        
        $this->MainService = $service;
        $this->Params = $params;
        $this->Controls = $controls;
        
        $this->loadBackgroundServices();
        $this->loadMainService();
        $this->loadBackgroundServices(TRUE);
    }
    
    public function checkForAvailability () {
        if(file_exists(S_DIR.$this->MainService.".php")) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
    
    private function loadMainService () {
        $available = $this->checkForAvailability();
        
        if($available) {
            include S_DIR.$this->MainService.".php";
            $tmp = new $this->MainService;
            $tmp->init($this->Params);
        } else {
            echo 'Error occured!';
        }
    }
    
    private function loadBackgroundServices ($afterMain=FALSE) {
        if($afterMain) {
            foreach($this->SettingsList AS $bgsn => $bgsa) {
                if($bgsa['active'] && $bgsa['afterMain']) include($this->BgDir.$bgsn.".php");
            }
        } else {
            foreach($this->SettingsList AS $bgsn => $bgsa) {
                if($bgsa['active'] && !$bgsa['afterMain']) include($this->BgDir.$bgsn.".php");
            }
        }
    }
}
?>